/*
 *	Graph class v1.0
 *	Copyright (C) 2007 by Karol Kozłowski
 *
 */

#include <iostream>

using namespace std;

class graph {									// implementacja grafu
    friend class dijkstra;
    friend class bellman_ford;
	friend class floyd_warshall;
	friend class ford_fulkerson;
	
    int **links;
    int numJoints;								// liczba połączeń
    int numVertex;								// liczba wierzchołków

	void weight(int a, int b, int c) {			// ustawia wagę węzła a-b na c
		links[a][b] = c;
	}

	public:
    graph(string filename);
	graph(graph *g);								// konstruktor kopiujący
	graph(int nVertex, int nJoints, int initial);	// tworzy pusty graf o podanych parametrach
	~graph();

	int weight(int a, int b) {
		return links[a][b];
	}
};
